/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"



/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.

   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it
   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.c) to fill in the CLOBBERs.


   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/


extern rtx_insn *gen_split_1 (rtx_insn *, rtx *);




static int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern0 (x3, E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern0 (x3, E_SImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (pattern0 (x3, E_DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !nvptx_register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nvptx_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!nvptx_register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 3;

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

static int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!nvptx_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !nvptx_register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nvptx_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!nvptx_register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!nvptx_nonmemory_operand (operands[2], E_SImode))
    return -1;
  return pattern4 (x3); /* [-1, 2] */
}

static int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_BImode:
      return pattern0 (x3, E_BImode); /* [-1, 0] */

    case E_HImode:
      if (pattern0 (x3, E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern0 (x3, E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern0 (x3, E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

static int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode))
        return -1;
      return pattern7 (x3, E_SFmode); /* [-1, 1] */

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode))
        return -1;
      res = pattern7 (x3, E_DFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern9 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern9 (x3, E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern9 (x3, E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern0 (x1, E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern0 (x1, E_SImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (pattern0 (x1, E_DImode) != 0)
        return -1;
      return 2;

    case E_SFmode:
      if (pattern0 (x1, E_SFmode) != 0)
        return -1;
      return 3;

    case E_DFmode:
      if (pattern0 (x1, E_DFmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

static int
pattern12 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
      if (!nvptx_register_operand (x5, E_BImode))
        return -1;
      x6 = XEXP (x2, 1);
      switch (GET_CODE (x6))
        {
        case LABEL_REF:
          x7 = XEXP (x2, 2);
          if (GET_CODE (x7) != PC)
            return -1;
          x8 = XEXP (x1, 0);
          if (GET_CODE (x8) != PC)
            return -1;
          operands[0] = x5;
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          return 0;

        case CONST_INT:
        case CONST_DOUBLE:
        case REG:
          operands[2] = x6;
          x8 = XEXP (x1, 0);
          operands[0] = x8;
          operands[1] = x5;
          x7 = XEXP (x2, 2);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern12 (x2, E_HImode) != 0)
                return -1;
              return 1;

            case E_SImode:
              if (pattern12 (x2, E_SImode) != 0)
                return -1;
              return 2;

            case E_DImode:
              if (pattern12 (x2, E_DImode) != 0)
                return -1;
              return 3;

            case E_SFmode:
              if (pattern12 (x2, E_SFmode) != 0)
                return -1;
              return 4;

            case E_DFmode:
              if (pattern12 (x2, E_DFmode) != 0)
                return -1;
              return 5;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 18
          || GET_MODE (x5) != E_BImode)
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != PC)
        return -1;
      x10 = XVECEXP (x5, 0, 0);
      operands[0] = x10;
      if (!nvptx_register_operand (operands[0], E_BImode))
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      return 6;

    default:
      return -1;
    }
}

static int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !nvptx_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nvptx_register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!nvptx_register_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!nvptx_register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

static int
pattern15 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern16 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern15 (x1, E_HImode, E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern15 (x1, E_SImode, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern17 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_SImode:
      res = pattern17 (x1, E_SImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case E_DImode:
      res = pattern17 (x1, E_DImode);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!nvptx_nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nvptx_nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!nvptx_nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nvptx_nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!nvptx_nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern22 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[1] = x3;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[0] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!nvptx_register_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!nvptx_register_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern23 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern24 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x2, 1);
  operands[5] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern24 (x7, E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern24 (x7, E_SImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (pattern24 (x7, E_DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern24 (x1, E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern24 (x1, E_SImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (pattern24 (x1, E_DImode) != 0)
        return -1;
      return 2;

    case E_SFmode:
      if (pattern24 (x1, E_SFmode) != 0)
        return -1;
      return 3;

    case E_DFmode:
      if (pattern24 (x1, E_DFmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

static int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x2, 1);
  operands[5] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  return pattern26 (x7); /* [-1, 4] */
}

static int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[0], E_HImode)
          || GET_MODE (x7) != E_HImode
          || !nvptx_register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nvptx_register_operand (operands[0], E_SImode)
          || GET_MODE (x7) != E_SImode
          || !nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!nvptx_register_operand (operands[0], E_DImode)
          || GET_MODE (x7) != E_DImode
          || !nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x7) != E_SFmode
          || !nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 3;

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x7) != E_DFmode
          || !nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

static int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  x6 = XEXP (x4, 1);
  operands[4] = x6;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!nvptx_register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !nvptx_register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nvptx_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!nvptx_register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x2, 1);
  operands[5] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  if (!nvptx_nonmemory_operand (operands[2], E_SImode))
    return -1;
  return pattern30 (x7); /* [-1, 2] */
}

static int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x2, 1);
  operands[5] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_BImode:
      return pattern24 (x7, E_BImode); /* [-1, 0] */

    case E_HImode:
      if (pattern24 (x7, E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern24 (x7, E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern24 (x7, E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

static int
pattern33 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode))
        return -1;
      return pattern33 (x7, E_SFmode); /* [-1, 1] */

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode))
        return -1;
      res = pattern33 (x7, E_DFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern35 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern35 (x7, E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern35 (x7, E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern37 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern38 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  x8 = XEXP (x2, 1);
  switch (XWINT (x8, 0))
    {
    case 16L:
      return pattern37 (x1, E_HImode, E_SImode); /* [-1, 0] */

    case 32L:
      if (pattern37 (x1, E_SImode, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern39 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_double_operand (operands[2], i1)
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  return 0;
}

static int
pattern40 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern41 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern42 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern43 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || !nvptx_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[2], E_HImode)
          || !nvptx_nonmemory_operand (operands[3], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nvptx_register_operand (operands[2], E_SImode)
          || !nvptx_nonmemory_operand (operands[3], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!nvptx_register_operand (operands[2], E_DImode)
          || !nvptx_nonmemory_operand (operands[3], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern44 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || !nvptx_float_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[2], E_SFmode)
          || !nvptx_nonmemory_operand (operands[3], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[2], E_DFmode)
          || !nvptx_nonmemory_operand (operands[3], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern45 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_nonmemory_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[4] = x5;
  x6 = XEXP (x5, 0);
  operands[5] = x6;
  x7 = XEXP (x5, 1);
  operands[6] = x7;
  if (!nvptx_register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  if (!nvptx_register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x4, 1);
  operands[2] = x9;
  if (!nvptx_register_operand (operands[2], E_SImode))
    return -1;
  x10 = XEXP (x3, 1);
  operands[3] = x10;
  if (!nvptx_register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

static int
pattern47 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  return 0;
}

static int
pattern48 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x6) != E_SFmode
          || !nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x6) != E_DFmode
          || !nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_SImode:
      res = pattern48 (x6, E_SImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case E_DImode:
      res = pattern48 (x6, E_DImode);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x6) != E_SFmode
          || !nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x6) != E_DFmode
          || !nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern51 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern52 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern51 (x1, E_HImode, E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern51 (x1, E_SImode, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern53 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!nvptx_nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nvptx_nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern54 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!nvptx_nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nvptx_nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!nvptx_nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern55 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_register_operand (operands[0], i1))
    return -1;
  return 0;
}

static int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      return pattern55 (x1, E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern55 (x1, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern57 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern58 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern59 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!nvptx_register_operand (operands[1], E_BImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern58 (x1, E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern58 (x1, E_SImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (pattern58 (x1, E_DImode) != 0)
        return -1;
      return 2;

    case E_SFmode:
      if (pattern58 (x1, E_SFmode) != 0)
        return -1;
      return 3;

    case E_DFmode:
      if (pattern58 (x1, E_DFmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

static int
pattern60 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern61 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern62 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  x8 = XEXP (x2, 1);
  switch (XWINT (x8, 0))
    {
    case 16L:
      return pattern61 (x1, E_HImode, E_SImode); /* [-1, 0] */

    case 32L:
      if (pattern61 (x1, E_SImode, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern63 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_double_operand (operands[2], i1)
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  return 0;
}

static int
pattern64 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern65 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern66 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern67 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || !nvptx_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[2], E_HImode)
          || !nvptx_nonmemory_operand (operands[3], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nvptx_register_operand (operands[2], E_SImode)
          || !nvptx_nonmemory_operand (operands[3], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!nvptx_register_operand (operands[2], E_DImode)
          || !nvptx_nonmemory_operand (operands[3], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern68 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || !nvptx_float_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[2], E_SFmode)
          || !nvptx_nonmemory_operand (operands[3], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[2], E_DFmode)
          || !nvptx_nonmemory_operand (operands[3], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern69 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_nonmemory_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern70 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  return 0;
}

static int
pattern71 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

static int
pattern72 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_register_operand (operands[0], i1))
    return -1;
  return 0;
}

static int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      return pattern72 (x1, E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern72 (x1, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern74 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern75 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

static int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_BImode:
      switch (pattern43 (E_BImode))
        {
        case 0:
          return 116; /* *cmphi */

        case 1:
          return 117; /* *cmpsi */

        case 2:
          return 118; /* *cmpdi */

        default:
          break;
        }
      break;

    case E_SImode:
      switch (pattern43 (E_SImode))
        {
        case 0:
          return 137; /* setcc_inthi */

        case 1:
          return 138; /* setcc_intsi */

        case 2:
          return 139; /* setcc_intdi */

        default:
          break;
        }
      break;

    case E_SFmode:
      switch (pattern43 (E_SFmode))
        {
        case 0:
          return 142; /* setcc_floathi */

        case 1:
          return 143; /* setcc_floatsi */

        case 2:
          return 144; /* setcc_floatdi */

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != NE
      || GET_MODE (x2) != E_SImode
      || x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !nvptx_register_operand (operands[0], E_SImode))
    return -1;
  operands[1] = x3;
  if (!nvptx_register_operand (operands[1], E_BImode))
    return -1;
  return 126; /* setcc_from_bi */
}

static int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      switch (XINT (x3, 1))
        {
        case 0:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!const_int_operand (operands[1], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!nvptx_register_operand (operands[0], E_QImode)
                  || GET_MODE (x3) != E_QImode)
                return -1;
              return 10; /* load_arg_regqi */

            case E_HImode:
              if (!nvptx_register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode)
                return -1;
              return 11; /* load_arg_reghi */

            case E_SImode:
              if (!nvptx_register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              return 12; /* load_arg_regsi */

            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              return 13; /* load_arg_regdi */

            case E_SFmode:
              if (!nvptx_register_operand (operands[0], E_SFmode)
                  || GET_MODE (x3) != E_SFmode)
                return -1;
              return 14; /* load_arg_regsf */

            case E_DFmode:
              if (!nvptx_register_operand (operands[0], E_DFmode)
                  || GET_MODE (x3) != E_DFmode)
                return -1;
              return 15; /* load_arg_regdf */

            default:
              return -1;
            }

        case 10:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!nvptx_register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !nvptx_register_operand (operands[1], E_SImode))
                return -1;
              return 81; /* bitrevsi2 */

            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !nvptx_register_operand (operands[1], E_DImode))
                return -1;
              return 82; /* bitrevdi2 */

            default:
              return -1;
            }

        case 4:
          if (GET_MODE (x3) != E_SFmode
              || !nvptx_register_operand (operands[0], E_SFmode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!nvptx_register_operand (operands[1], E_SFmode)
              || !
#line 1031 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 175; /* sinsf2 */

        case 5:
          if (GET_MODE (x3) != E_SFmode
              || !nvptx_register_operand (operands[0], E_SFmode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!nvptx_register_operand (operands[1], E_SFmode)
              || !
#line 1038 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 176; /* cossf2 */

        case 2:
          if (GET_MODE (x3) != E_SFmode
              || !nvptx_register_operand (operands[0], E_SFmode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!nvptx_register_operand (operands[1], E_SFmode)
              || !
#line 1045 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 177; /* log2sf2 */

        case 3:
          if (GET_MODE (x3) != E_SFmode
              || !nvptx_register_operand (operands[0], E_SFmode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!nvptx_register_operand (operands[1], E_SFmode)
              || !
#line 1052 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 178; /* exp2sf2 */

        case 6:
          switch (pattern18 (x3))
            {
            case 0:
              return 197; /* floorsf2 */

            case 1:
              return 201; /* floordf2 */

            case 2:
              return 205; /* lfloorsfsi2 */

            case 3:
              return 207; /* lfloordfsi2 */

            case 4:
              return 209; /* lfloorsfdi2 */

            case 5:
              return 211; /* lfloordfdi2 */

            default:
              return -1;
            }

        case 7:
          switch (pattern19 (x3))
            {
            case 0:
              return 198; /* btruncsf2 */

            case 1:
              return 202; /* btruncdf2 */

            default:
              return -1;
            }

        case 8:
          switch (pattern18 (x3))
            {
            case 0:
              return 199; /* ceilsf2 */

            case 1:
              return 203; /* ceildf2 */

            case 2:
              return 206; /* lceilsfsi2 */

            case 3:
              return 208; /* lceildfsi2 */

            case 4:
              return 210; /* lceilsfdi2 */

            case 5:
              return 212; /* lceildfdi2 */

            default:
              return -1;
            }

        case 9:
          switch (pattern19 (x3))
            {
            case 0:
              return 200; /* nearbyintsf2 */

            case 1:
              return 204; /* nearbyintdf2 */

            default:
              return -1;
            }

        case 13:
          if (GET_MODE (x3) != E_SImode
              || !nvptx_register_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          return 232; /* oacc_dim_size */

        case 15:
          if (GET_MODE (x3) != E_SImode
              || !nvptx_register_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!nvptx_register_operand (operands[1], E_BImode))
            return -1;
          return 240; /* nvptx_vote_ballot */

        case 16:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !nvptx_register_operand (operands[0], E_SImode))
            return -1;
          return 245; /* omp_simt_lane */

        default:
          return -1;
        }

    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      switch (XINT (x3, 1))
        {
        case 1:
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern41 (x3, E_SFmode) != 0)
                return -1;
              return 163; /* copysignsf3 */

            case E_DFmode:
              if (pattern41 (x3, E_DFmode) != 0)
                return -1;
              return 164; /* copysigndf3 */

            default:
              return -1;
            }

        case 14:
          if (!nvptx_register_operand (operands[1], E_SImode)
              || !nvptx_register_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              return 248; /* packsidi2 */

            case E_DFmode:
              if (!nvptx_register_operand (operands[0], E_DFmode)
                  || GET_MODE (x3) != E_DFmode)
                return -1;
              return 249; /* packsidf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      if (XINT (x3, 1) != 17)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!nvptx_nonmemory_operand (operands[2], E_SImode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !nvptx_register_operand (operands[1], E_SImode))
            return -1;
          return 238; /* nvptx_shufflesi */

        case E_SFmode:
          if (!nvptx_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !nvptx_register_operand (operands[1], E_SFmode))
            return -1;
          return 239; /* nvptx_shufflesf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_QImode)
        return -1;
      operands[2] = x1;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!call_insn_operand (operands[0], E_SImode)
              || !
#line 206 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
            return -1;
          return 147; /* call_insn_si */

        case E_DImode:
          if (!call_insn_operand (operands[0], E_DImode)
              || !
#line 206 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
            return -1;
          return 148; /* call_insn_di */

        default:
          return -1;
        }

    case SET:
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != CALL)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_QImode)
        return -1;
      operands[3] = x1;
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      if (!nvptx_register_operand (operands[0], E_VOIDmode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!call_insn_operand (operands[1], E_SImode)
              || !
#line 206 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
            return -1;
          return 149; /* call_value_insn_si */

        case E_DImode:
          if (!call_insn_operand (operands[1], E_DImode)
              || !
#line 206 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
            return -1;
          return 150; /* call_value_insn_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_BImode:
      if (!nvptx_register_operand (operands[0], E_BImode)
          || !nvptx_nonmemory_operand (operands[1], E_BImode))
        return -1;
      return 317; /* *p movbi */

    case E_V2SImode:
      if (!nonimmediate_operand (operands[0], E_V2SImode)
          || !general_operand (operands[1], E_V2SImode)
          || !
#line 226 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 318; /* *p *movv2si_insn */

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || !general_operand (operands[1], E_V2DImode)
          || !
#line 226 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 319; /* *p *movv2di_insn */

    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !general_operand (operands[1], E_QImode)
          || !
#line 240 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 320; /* *p *movqi_insn */

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !general_operand (operands[1], E_HImode)
          || !
#line 240 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 321; /* *p *movhi_insn */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !general_operand (operands[1], E_SImode)
          || !
#line 240 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 322; /* *p *movsi_insn */

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !general_operand (operands[1], E_DImode)
          || !
#line 240 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 323; /* *p *movdi_insn */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !general_operand (operands[1], E_SFmode)
          || !
#line 265 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 324; /* *p *movsf_insn */

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !general_operand (operands[1], E_DFmode)
          || !
#line 265 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 325; /* *p *movdf_insn */

    default:
      return -1;
    }
}

static int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[4] = x2;
  x3 = XEXP (x2, 0);
  operands[5] = x3;
  x4 = XEXP (x2, 1);
  operands[6] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_BImode:
      switch (pattern67 (E_BImode))
        {
        case 0:
          return 432; /* *p *cmphi */

        case 1:
          return 433; /* *p *cmpsi */

        case 2:
          return 434; /* *p *cmpdi */

        default:
          return -1;
        }

    case E_SImode:
      switch (pattern67 (E_SImode))
        {
        case 0:
          return 449; /* *p setcc_inthi */

        case 1:
          return 450; /* *p setcc_intsi */

        case 2:
          return 451; /* *p setcc_intdi */

        default:
          return -1;
        }

    case E_SFmode:
      switch (pattern67 (E_SFmode))
        {
        case 0:
          return 454; /* *p setcc_floathi */

        case 1:
          return 455; /* *p setcc_floatsi */

        case 2:
          return 456; /* *p setcc_floatdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  res = recog_5 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (GET_CODE (x3) != NE
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[2] = x5;
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  x7 = XEXP (x5, 1);
  operands[4] = x7;
  if (!nvptx_register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  if (!nvptx_register_operand (operands[1], E_BImode))
    return -1;
  return 438; /* *p setcc_from_bi */
}

static int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      switch (XINT (x4, 1))
        {
        case 0:
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          if (!const_int_operand (operands[1], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!nvptx_register_operand (operands[0], E_QImode)
                  || GET_MODE (x4) != E_QImode)
                return -1;
              return 326; /* *p load_arg_regqi */

            case E_HImode:
              if (!nvptx_register_operand (operands[0], E_HImode)
                  || GET_MODE (x4) != E_HImode)
                return -1;
              return 327; /* *p load_arg_reghi */

            case E_SImode:
              if (!nvptx_register_operand (operands[0], E_SImode)
                  || GET_MODE (x4) != E_SImode)
                return -1;
              return 328; /* *p load_arg_regsi */

            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x4) != E_DImode)
                return -1;
              return 329; /* *p load_arg_regdi */

            case E_SFmode:
              if (!nvptx_register_operand (operands[0], E_SFmode)
                  || GET_MODE (x4) != E_SFmode)
                return -1;
              return 330; /* *p load_arg_regsf */

            case E_DFmode:
              if (!nvptx_register_operand (operands[0], E_DFmode)
                  || GET_MODE (x4) != E_DFmode)
                return -1;
              return 331; /* *p load_arg_regdf */

            default:
              return -1;
            }

        case 10:
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!nvptx_register_operand (operands[0], E_SImode)
                  || GET_MODE (x4) != E_SImode
                  || !nvptx_register_operand (operands[1], E_SImode))
                return -1;
              return 397; /* *p bitrevsi2 */

            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x4) != E_DImode
                  || !nvptx_register_operand (operands[1], E_DImode))
                return -1;
              return 398; /* *p bitrevdi2 */

            default:
              return -1;
            }

        case 4:
          if (GET_MODE (x4) != E_SFmode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          if (!nvptx_register_operand (operands[0], E_SFmode))
            return -1;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          if (!nvptx_register_operand (operands[1], E_SFmode)
              || !
#line 1031 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 487; /* *p sinsf2 */

        case 5:
          if (GET_MODE (x4) != E_SFmode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          if (!nvptx_register_operand (operands[0], E_SFmode))
            return -1;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          if (!nvptx_register_operand (operands[1], E_SFmode)
              || !
#line 1038 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 488; /* *p cossf2 */

        case 2:
          if (GET_MODE (x4) != E_SFmode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          if (!nvptx_register_operand (operands[0], E_SFmode))
            return -1;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          if (!nvptx_register_operand (operands[1], E_SFmode)
              || !
#line 1045 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 489; /* *p log2sf2 */

        case 3:
          if (GET_MODE (x4) != E_SFmode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          if (!nvptx_register_operand (operands[0], E_SFmode))
            return -1;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          if (!nvptx_register_operand (operands[1], E_SFmode)
              || !
#line 1052 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 490; /* *p exp2sf2 */

        case 6:
          switch (pattern49 (x1))
            {
            case 0:
              return 509; /* *p floorsf2 */

            case 1:
              return 513; /* *p floordf2 */

            case 2:
              return 517; /* *p lfloorsfsi2 */

            case 3:
              return 519; /* *p lfloordfsi2 */

            case 4:
              return 521; /* *p lfloorsfdi2 */

            case 5:
              return 523; /* *p lfloordfdi2 */

            default:
              return -1;
            }

        case 7:
          switch (pattern50 (x1))
            {
            case 0:
              return 510; /* *p btruncsf2 */

            case 1:
              return 514; /* *p btruncdf2 */

            default:
              return -1;
            }

        case 8:
          switch (pattern49 (x1))
            {
            case 0:
              return 511; /* *p ceilsf2 */

            case 1:
              return 515; /* *p ceildf2 */

            case 2:
              return 518; /* *p lceilsfsi2 */

            case 3:
              return 520; /* *p lceildfsi2 */

            case 4:
              return 522; /* *p lceilsfdi2 */

            case 5:
              return 524; /* *p lceildfdi2 */

            default:
              return -1;
            }

        case 9:
          switch (pattern50 (x1))
            {
            case 0:
              return 512; /* *p nearbyintsf2 */

            case 1:
              return 516; /* *p nearbyintdf2 */

            default:
              return -1;
            }

        case 13:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          if (!nvptx_register_operand (operands[0], E_SImode))
            return -1;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          return 541; /* *p oacc_dim_size */

        case 15:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          if (!nvptx_register_operand (operands[0], E_SImode))
            return -1;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          if (!nvptx_register_operand (operands[1], E_BImode))
            return -1;
          return 545; /* *p nvptx_vote_ballot */

        case 16:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x8 = XVECEXP (x4, 0, 0);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XEXP (x1, 0);
          operands[1] = x5;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          x7 = XEXP (x5, 1);
          operands[3] = x7;
          if (!nvptx_register_operand (operands[0], E_SImode))
            return -1;
          return 550; /* *p omp_simt_lane */

        default:
          return -1;
        }

    case 2:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x7 = XEXP (x5, 1);
      operands[5] = x7;
      x8 = XVECEXP (x4, 0, 0);
      operands[1] = x8;
      x9 = XVECEXP (x4, 0, 1);
      operands[2] = x9;
      switch (XINT (x4, 1))
        {
        case 1:
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern65 (x4, E_SFmode) != 0)
                return -1;
              return 475; /* *p copysignsf3 */

            case E_DFmode:
              if (pattern65 (x4, E_DFmode) != 0)
                return -1;
              return 476; /* *p copysigndf3 */

            default:
              return -1;
            }

        case 14:
          if (!nvptx_register_operand (operands[1], E_SImode)
              || !nvptx_register_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x4) != E_DImode)
                return -1;
              return 553; /* *p packsidi2 */

            case E_DFmode:
              if (!nvptx_register_operand (operands[0], E_DFmode)
                  || GET_MODE (x4) != E_DFmode)
                return -1;
              return 554; /* *p packsidf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      if (XINT (x4, 1) != 17)
        return -1;
      x5 = XEXP (x1, 0);
      operands[4] = x5;
      x6 = XEXP (x5, 0);
      operands[5] = x6;
      x7 = XEXP (x5, 1);
      operands[6] = x7;
      x8 = XVECEXP (x4, 0, 0);
      operands[1] = x8;
      x9 = XVECEXP (x4, 0, 1);
      operands[2] = x9;
      if (!nvptx_nonmemory_operand (operands[2], E_SImode))
        return -1;
      x10 = XVECEXP (x4, 0, 2);
      operands[3] = x10;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !nvptx_register_operand (operands[1], E_SImode))
            return -1;
          return 543; /* *p nvptx_shufflesi */

        case E_SFmode:
          if (!nvptx_register_operand (operands[0], E_SFmode)
              || GET_MODE (x4) != E_SFmode
              || !nvptx_register_operand (operands[1], E_SFmode))
            return -1;
          return 544; /* *p nvptx_shufflesf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x3))
    {
    case CALL:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_QImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x7 = XEXP (x5, 1);
      operands[5] = x7;
      operands[2] = x2;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      x9 = XEXP (x3, 1);
      operands[1] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!call_insn_operand (operands[0], E_SImode)
              || !
#line 206 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
            return -1;
          return 459; /* *p call_insn_si */

        case E_DImode:
          if (!call_insn_operand (operands[0], E_DImode)
              || !
#line 206 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
            return -1;
          return 460; /* *p call_insn_di */

        default:
          return -1;
        }

    case SET:
      x9 = XEXP (x3, 1);
      if (GET_CODE (x9) != CALL)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != MEM
          || GET_MODE (x10) != E_QImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[4] = x5;
      x6 = XEXP (x5, 0);
      operands[5] = x6;
      x7 = XEXP (x5, 1);
      operands[6] = x7;
      operands[3] = x2;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (!nvptx_register_operand (operands[0], E_VOIDmode))
        return -1;
      x11 = XEXP (x10, 0);
      operands[1] = x11;
      x12 = XEXP (x9, 1);
      operands[2] = x12;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!call_insn_operand (operands[1], E_SImode)
              || !
#line 206 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
            return -1;
          return 461; /* *p call_value_insn_si */

        case E_DImode:
          if (!call_insn_operand (operands[1], E_DImode)
              || !
#line 206 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
            return -1;
          return 462; /* *p call_value_insn_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      res = recog_4 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x3) != LABEL_REF)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x1, 0);
      operands[1] = x5;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      x8 = XEXP (x3, 0);
      operands[0] = x8;
      return 437; /* *p jump */

    case UNSPEC:
      return recog_7 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!nvptx_register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !nvptx_nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 332; /* *p zero_extendqihi2 */

        case E_SImode:
          switch (pattern53 (x3))
            {
            case 0:
              return 333; /* *p zero_extendqisi2 */

            case 1:
              return 334; /* *p zero_extendhisi2 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern54 (x3))
            {
            case 0:
              return 335; /* *p zero_extendqidi2 */

            case 1:
              return 336; /* *p zero_extendhidi2 */

            case 2:
              return 337; /* *p zero_extendsidi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!nvptx_register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !nvptx_register_operand (operands[1], E_QImode))
            return -1;
          return 338; /* *p extendqihi2 */

        case E_SImode:
          switch (pattern53 (x3))
            {
            case 0:
              return 339; /* *p extendqisi2 */

            case 1:
              return 340; /* *p extendhisi2 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern54 (x3))
            {
            case 0:
              return 341; /* *p extendqidi2 */

            case 1:
              return 342; /* *p extendhidi2 */

            case 2:
              return 343; /* *p extendsidi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      switch (GET_CODE (x8))
        {
        case REG:
          operands[1] = x8;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!nvptx_nonimmediate_operand (operands[0], E_QImode)
                  || GET_MODE (x3) != E_QImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_HImode:
                  if (!nvptx_register_operand (operands[1], E_HImode))
                    return -1;
                  return 344; /* *p trunchiqi2 */

                case E_SImode:
                  if (!nvptx_register_operand (operands[1], E_SImode))
                    return -1;
                  return 345; /* *p truncsiqi2 */

                case E_DImode:
                  if (!nvptx_register_operand (operands[1], E_DImode))
                    return -1;
                  return 347; /* *p truncdiqi2 */

                default:
                  return -1;
                }

            case E_HImode:
              if (!nvptx_nonimmediate_operand (operands[0], E_HImode))
                return -1;
              switch (pattern33 (x3, E_HImode))
                {
                case 0:
                  return 346; /* *p truncsihi2 */

                case 1:
                  return 348; /* *p truncdihi2 */

                default:
                  return -1;
                }

            case E_SImode:
              if (!nvptx_nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !nvptx_register_operand (operands[1], E_DImode))
                return -1;
              return 349; /* *p truncdisi2 */

            default:
              return -1;
            }

        case LSHIFTRT:
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != MULT)
            return -1;
          x10 = XEXP (x8, 1);
          if (GET_CODE (x10) != CONST_INT)
            return -1;
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          x6 = XEXP (x5, 0);
          operands[4] = x6;
          x7 = XEXP (x5, 1);
          operands[5] = x7;
          x11 = XEXP (x9, 0);
          switch (GET_CODE (x11))
            {
            case SIGN_EXTEND:
              switch (pattern62 (x3, SIGN_EXTEND))
                {
                case 0:
                  return 407; /* *p smulhi3_highpart */

                case 1:
                  return 408; /* *p smulsi3_highpart */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern62 (x3, ZERO_EXTEND))
                {
                case 0:
                  return 409; /* *p umulhi3_highpart */

                case 1:
                  return 410; /* *p umulsi3_highpart */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      switch (GET_CODE (x8))
        {
        case REG:
          operands[1] = x8;
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          x6 = XEXP (x5, 0);
          operands[4] = x6;
          x7 = XEXP (x5, 1);
          operands[5] = x7;
          switch (pattern26 (x3))
            {
            case 0:
              return 350; /* *p addhi3 */

            case 1:
              return 351; /* *p addsi3 */

            case 2:
              return 352; /* *p adddi3 */

            case 3:
              return 463; /* *p addsf3 */

            case 4:
              return 464; /* *p adddf3 */

            default:
              return -1;
            }

        case PLUS:
          if (pattern46 (x1) != 0)
            return -1;
          return 353; /* *p *vadd_addsi4 */

        case MINUS:
          if (pattern46 (x1) != 0)
            return -1;
          return 354; /* *p *vsub_addsi4 */

        case MULT:
          x5 = XEXP (x1, 0);
          operands[4] = x5;
          x6 = XEXP (x5, 0);
          operands[5] = x6;
          x7 = XEXP (x5, 1);
          operands[6] = x7;
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          x10 = XEXP (x8, 1);
          operands[2] = x10;
          x12 = XEXP (x3, 1);
          operands[3] = x12;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern66 (x3, E_HImode) != 0)
                return -1;
              return 361; /* *p *madhi3 */

            case E_SImode:
              if (pattern66 (x3, E_SImode) != 0)
                return -1;
              return 362; /* *p *madsi3 */

            case E_DImode:
              if (pattern66 (x3, E_DImode) != 0)
                return -1;
              return 363; /* *p *maddi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x7 = XEXP (x5, 1);
      operands[5] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      x12 = XEXP (x3, 1);
      operands[2] = x12;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern57 (x3, E_HImode) != 0)
            return -1;
          return 355; /* *p subhi3 */

        case E_SImode:
          if (pattern57 (x3, E_SImode) != 0)
            return -1;
          return 356; /* *p subsi3 */

        case E_DImode:
          if (pattern57 (x3, E_DImode) != 0)
            return -1;
          return 357; /* *p subdi3 */

        case E_SFmode:
          if (pattern57 (x3, E_SFmode) != 0)
            return -1;
          return 465; /* *p subsf3 */

        case E_DFmode:
          if (pattern57 (x3, E_DFmode) != 0)
            return -1;
          return 466; /* *p subdf3 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x7 = XEXP (x5, 1);
      operands[5] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      switch (GET_CODE (x8))
        {
        case REG:
          operands[1] = x8;
          switch (pattern26 (x3))
            {
            case 0:
              return 358; /* *p mulhi3 */

            case 1:
              return 359; /* *p mulsi3 */

            case 2:
              return 360; /* *p muldi3 */

            case 3:
              return 467; /* *p mulsf3 */

            case 4:
              return 468; /* *p muldf3 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern52 (x3, SIGN_EXTEND))
            {
            case 0:
              return 403; /* *p mulhisi3 */

            case 1:
              return 404; /* *p mulsidi3 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern52 (x3, ZERO_EXTEND))
            {
            case 0:
              return 405; /* *p umulhisi3 */

            case 1:
              return 406; /* *p umulsidi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case DIV:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x7 = XEXP (x5, 1);
      operands[5] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      switch (GET_CODE (x8))
        {
        case REG:
          operands[1] = x8;
          switch (pattern26 (x3))
            {
            case 0:
              return 364; /* *p divhi3 */

            case 1:
              return 365; /* *p divsi3 */

            case 2:
              return 366; /* *p divdi3 */

            case 3:
              return 473; /* *p divsf3 */

            case 4:
              return 474; /* *p divdf3 */

            default:
              return -1;
            }

        case CONST_DOUBLE:
          operands[2] = x8;
          x12 = XEXP (x3, 1);
          operands[1] = x12;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern63 (x3, E_SFmode) != 0
                  || !
#line 965 "../../gcc/config/nvptx/nvptx.md"
(CONST_DOUBLE_P (operands[2])
   && real_identical (CONST_DOUBLE_REAL_VALUE (operands[2]), &dconst1)))
                return -1;
              return 471; /* *p *recipsf2 */

            case E_DFmode:
              if (pattern63 (x3, E_DFmode) != 0
                  || !
#line 965 "../../gcc/config/nvptx/nvptx.md"
(CONST_DOUBLE_P (operands[2])
   && real_identical (CONST_DOUBLE_REAL_VALUE (operands[2]), &dconst1)))
                return -1;
              return 472; /* *p *recipdf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UDIV:
      switch (pattern25 (x1))
        {
        case 0:
          return 367; /* *p udivhi3 */

        case 1:
          return 368; /* *p udivsi3 */

        case 2:
          return 369; /* *p udivdi3 */

        default:
          return -1;
        }

    case MOD:
      switch (pattern25 (x1))
        {
        case 0:
          return 370; /* *p modhi3 */

        case 1:
          return 371; /* *p modsi3 */

        case 2:
          return 372; /* *p moddi3 */

        default:
          return -1;
        }

    case UMOD:
      switch (pattern25 (x1))
        {
        case 0:
          return 373; /* *p umodhi3 */

        case 1:
          return 374; /* *p umodsi3 */

        case 2:
          return 375; /* *p umoddi3 */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern27 (x1))
        {
        case 0:
          return 376; /* *p sminhi3 */

        case 1:
          return 377; /* *p sminsi3 */

        case 2:
          return 378; /* *p smindi3 */

        case 3:
          return 477; /* *p sminsf3 */

        case 4:
          return 478; /* *p smindf3 */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern25 (x1))
        {
        case 0:
          return 379; /* *p uminhi3 */

        case 1:
          return 380; /* *p uminsi3 */

        case 2:
          return 381; /* *p umindi3 */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern27 (x1))
        {
        case 0:
          return 382; /* *p smaxhi3 */

        case 1:
          return 383; /* *p smaxsi3 */

        case 2:
          return 384; /* *p smaxdi3 */

        case 3:
          return 479; /* *p smaxsf3 */

        case 4:
          return 480; /* *p smaxdf3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern25 (x1))
        {
        case 0:
          return 385; /* *p umaxhi3 */

        case 1:
          return 386; /* *p umaxsi3 */

        case 2:
          return 387; /* *p umaxdi3 */

        default:
          return -1;
        }

    case ABS:
      switch (pattern28 (x1))
        {
        case 0:
          return 388; /* *p abshi2 */

        case 1:
          return 389; /* *p abssi2 */

        case 2:
          return 390; /* *p absdi2 */

        case 3:
          return 481; /* *p abssf2 */

        case 4:
          return 482; /* *p absdf2 */

        default:
          return -1;
        }

    case NEG:
      switch (pattern28 (x1))
        {
        case 0:
          return 391; /* *p neghi2 */

        case 1:
          return 392; /* *p negsi2 */

        case 2:
          return 393; /* *p negdi2 */

        case 3:
          return 483; /* *p negsf2 */

        case 4:
          return 484; /* *p negdf2 */

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      switch (pattern30 (x3))
        {
        case 0:
          return 394; /* *p one_cmplhi2 */

        case 1:
          return 395; /* *p one_cmplsi2 */

        case 2:
          return 396; /* *p one_cmpldi2 */

        default:
          return -1;
        }

    case CLZ:
      switch (pattern29 (x1))
        {
        case 0:
          return 399; /* *p clzsi2 */

        case 1:
          return 400; /* *p clzdi2 */

        default:
          return -1;
        }

    case POPCOUNT:
      switch (pattern29 (x1))
        {
        case 0:
          return 401; /* *p popcountsi2 */

        case 1:
          return 402; /* *p popcountdi2 */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern31 (x1))
        {
        case 0:
          return 411; /* *p ashlhi3 */

        case 1:
          return 412; /* *p ashlsi3 */

        case 2:
          return 413; /* *p ashldi3 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern31 (x1))
        {
        case 0:
          return 414; /* *p ashrhi3 */

        case 1:
          return 415; /* *p ashrsi3 */

        case 2:
          return 416; /* *p ashrdi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern31 (x1))
        {
        case 0:
          return 417; /* *p lshrhi3 */

        case 1:
          return 418; /* *p lshrsi3 */

        case 2:
          return 419; /* *p lshrdi3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern32 (x1))
        {
        case 0:
          return 420; /* *p andbi3 */

        case 1:
          return 421; /* *p andhi3 */

        case 2:
          return 422; /* *p andsi3 */

        case 3:
          return 423; /* *p anddi3 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern32 (x1))
        {
        case 0:
          return 424; /* *p iorbi3 */

        case 1:
          return 425; /* *p iorhi3 */

        case 2:
          return 426; /* *p iorsi3 */

        case 3:
          return 427; /* *p iordi3 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern32 (x1))
        {
        case 0:
          return 428; /* *p xorbi3 */

        case 1:
          return 429; /* *p xorhi3 */

        case 2:
          return 430; /* *p xorsi3 */

        case 3:
          return 431; /* *p xordi3 */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          res = recog_6 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[1] = x3;
          x5 = XEXP (x1, 0);
          operands[4] = x5;
          x6 = XEXP (x5, 0);
          operands[5] = x6;
          x7 = XEXP (x5, 1);
          operands[6] = x7;
          x8 = XEXP (x3, 0);
          operands[2] = x8;
          x12 = XEXP (x3, 1);
          operands[3] = x12;
          switch (GET_MODE (operands[0]))
            {
            case E_BImode:
              switch (pattern68 (E_BImode))
                {
                case 0:
                  return 435; /* *p *cmpsf */

                case 1:
                  return 436; /* *p *cmpdf */

                default:
                  return -1;
                }

            case E_SImode:
              switch (pattern68 (E_SImode))
                {
                case 0:
                  return 452; /* *p setcc_intsf */

                case 1:
                  return 453; /* *p setcc_intdf */

                default:
                  return -1;
                }

            case E_SFmode:
              switch (pattern68 (E_SFmode))
                {
                case 0:
                  return 457; /* *p setcc_floatsf */

                case 1:
                  return 458; /* *p setcc_floatdf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      x5 = XEXP (x1, 0);
      operands[4] = x5;
      x6 = XEXP (x5, 0);
      operands[5] = x6;
      x7 = XEXP (x5, 1);
      operands[6] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x12 = XEXP (x3, 1);
      operands[2] = x12;
      x13 = XEXP (x3, 2);
      operands[3] = x13;
      x8 = XEXP (x3, 0);
      switch (GET_CODE (x8))
        {
        case NE:
          switch (pattern59 (x3))
            {
            case 0:
              return 439; /* *p sel_truehi */

            case 1:
              return 440; /* *p sel_truesi */

            case 2:
              return 441; /* *p sel_truedi */

            case 3:
              return 442; /* *p sel_truesf */

            case 4:
              return 443; /* *p sel_truedf */

            default:
              return -1;
            }

        case EQ:
          switch (pattern59 (x3))
            {
            case 0:
              return 444; /* *p sel_falsehi */

            case 1:
              return 445; /* *p sel_falsesi */

            case 2:
              return 446; /* *p sel_falsedi */

            case 3:
              return 447; /* *p sel_falsesf */

            case 4:
              return 448; /* *p sel_falsedf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FMA:
      x5 = XEXP (x1, 0);
      operands[4] = x5;
      x6 = XEXP (x5, 0);
      operands[5] = x6;
      x7 = XEXP (x5, 1);
      operands[6] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      x12 = XEXP (x3, 1);
      operands[2] = x12;
      x13 = XEXP (x3, 2);
      operands[3] = x13;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern64 (x3, E_SFmode) != 0)
            return -1;
          return 469; /* *p fmasf4 */

        case E_DFmode:
          if (pattern64 (x3, E_DFmode) != 0)
            return -1;
          return 470; /* *p fmadf4 */

        default:
          return -1;
        }

    case SQRT:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!nvptx_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !nvptx_register_operand (operands[1], E_SFmode))
            return -1;
          return 485; /* *p sqrtsf2 */

        case E_DFmode:
          if (!nvptx_register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !nvptx_register_operand (operands[1], E_DFmode))
            return -1;
          return 486; /* *p sqrtdf2 */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!nvptx_register_operand (operands[0], E_DFmode))
        return -1;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      if (!nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 491; /* *p extendsfdf2 */

    case FLOAT_TRUNCATE:
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!nvptx_register_operand (operands[0], E_SFmode))
        return -1;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      if (!nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 492; /* *p truncdfsf2 */

    case UNSIGNED_FLOAT:
      switch (pattern34 (x1))
        {
        case 0:
          return 493; /* *p floatunssisf2 */

        case 1:
          return 497; /* *p floatunsdisf2 */

        case 2:
          return 494; /* *p floatunssidf2 */

        case 3:
          return 498; /* *p floatunsdidf2 */

        default:
          return -1;
        }

    case FLOAT:
      switch (pattern34 (x1))
        {
        case 0:
          return 495; /* *p floatsisf2 */

        case 1:
          return 499; /* *p floatdisf2 */

        case 2:
          return 496; /* *p floatsidf2 */

        case 3:
          return 500; /* *p floatdidf2 */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern36 (x1))
        {
        case 0:
          return 501; /* *p fixuns_truncsfsi2 */

        case 1:
          return 502; /* *p fixuns_truncdfsi2 */

        case 2:
          return 505; /* *p fixuns_truncsfdi2 */

        case 3:
          return 506; /* *p fixuns_truncdfdi2 */

        default:
          return -1;
        }

    case FIX:
      switch (pattern36 (x1))
        {
        case 0:
          return 503; /* *p fix_truncsfsi2 */

        case 1:
          return 504; /* *p fix_truncdfsi2 */

        case 2:
          return 507; /* *p fix_truncsfdi2 */

        case 3:
          return 508; /* *p fix_truncdfdi2 */

        default:
          return -1;
        }

    case VEC_MERGE:
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != VEC_DUPLICATE)
        return -1;
      x13 = XEXP (x3, 2);
      if (GET_CODE (x13) != CONST_INT)
        return -1;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      x12 = XEXP (x3, 1);
      if (!rtx_equal_p (x12, operands[0]))
        return -1;
      switch (XWINT (x13, 0))
        {
        case 1L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern70 (x3, E_SImode, E_V2SImode) != 0)
                return -1;
              return 525; /* *p *vec_setv2si_0 */

            case E_V2DImode:
              if (pattern70 (x3, E_DImode, E_V2DImode) != 0)
                return -1;
              return 526; /* *p *vec_setv2di_0 */

            default:
              return -1;
            }

        case 2L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern70 (x3, E_SImode, E_V2SImode) != 0)
                return -1;
              return 527; /* *p *vec_setv2si_1 */

            case E_V2DImode:
              if (pattern70 (x3, E_DImode, E_V2DImode) != 0)
                return -1;
              return 528; /* *p *vec_setv2di_1 */

            default:
              return -1;
            }

        case 4L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern70 (x3, E_SImode, E_V2SImode) != 0)
                return -1;
              return 529; /* *p *vec_setv2si_2 */

            case E_V2DImode:
              if (pattern70 (x3, E_DImode, E_V2DImode) != 0)
                return -1;
              return 530; /* *p *vec_setv2di_2 */

            default:
              return -1;
            }

        case 8L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern70 (x3, E_SImode, E_V2SImode) != 0)
                return -1;
              return 531; /* *p *vec_setv2si_3 */

            case E_V2DImode:
              if (pattern70 (x3, E_DImode, E_V2DImode) != 0)
                return -1;
              return 532; /* *p *vec_setv2di_3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x12 = XEXP (x3, 1);
      if (GET_CODE (x12) != PARALLEL
          || XVECLEN (x12, 0) != 1)
        return -1;
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x7 = XEXP (x5, 1);
      operands[5] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      x14 = XVECEXP (x12, 0, 0);
      operands[2] = x14;
      if (!nvptx_vector_index_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !nvptx_register_operand (operands[1], E_V2SImode))
            return -1;
          return 533; /* *p vec_extractv2sisi */

        case E_DImode:
          if (!nvptx_register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !nvptx_register_operand (operands[1], E_V2DImode))
            return -1;
          return 534; /* *p vec_extractv2didi */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (XVECLEN (x3, 0))
        {
        case 1:
          if (XINT (x3, 1) != 6
              || GET_MODE (x3) != E_SImode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          if (!nvptx_register_operand (operands[0], E_SImode))
            return -1;
          x15 = XVECEXP (x3, 0, 0);
          operands[1] = x15;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          return 542; /* *p oacc_dim_pos */

        case 2:
          if (XINT (x3, 1) != 12)
            return -1;
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          x6 = XEXP (x5, 0);
          operands[4] = x6;
          x7 = XEXP (x5, 1);
          operands[5] = x7;
          x15 = XVECEXP (x3, 0, 0);
          operands[1] = x15;
          x16 = XVECEXP (x3, 0, 1);
          operands[2] = x16;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern69 (x3, E_SImode) != 0
                  || !
#line 206 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
                return -1;
              return 546; /* *p omp_simt_enter_si */

            case E_DImode:
              if (pattern69 (x3, E_DImode) != 0
                  || !
#line 206 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
                return -1;
              return 547; /* *p omp_simt_enter_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_BImode:
          if (nvptx_register_operand (operands[0], E_BImode)
              && nvptx_nonmemory_operand (operands[1], E_BImode))
            return 1; /* movbi */
          break;

        case E_V2SImode:
          if (nonimmediate_operand (operands[0], E_V2SImode)
              && general_operand (operands[1], E_V2SImode)
              && 
#line 226 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
            return 2; /* *movv2si_insn */
          break;

        case E_V2DImode:
          if (nonimmediate_operand (operands[0], E_V2DImode)
              && general_operand (operands[1], E_V2DImode)
              && 
#line 226 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
            return 3; /* *movv2di_insn */
          break;

        case E_QImode:
          if (nonimmediate_operand (operands[0], E_QImode)
              && general_operand (operands[1], E_QImode)
              && 
#line 240 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
            return 4; /* *movqi_insn */
          break;

        case E_HImode:
          if (nonimmediate_operand (operands[0], E_HImode)
              && general_operand (operands[1], E_HImode)
              && 
#line 240 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
            return 5; /* *movhi_insn */
          break;

        case E_SImode:
          if (nonimmediate_operand (operands[0], E_SImode)
              && general_operand (operands[1], E_SImode)
              && 
#line 240 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
            return 6; /* *movsi_insn */
          break;

        case E_DImode:
          if (nonimmediate_operand (operands[0], E_DImode)
              && general_operand (operands[1], E_DImode)
              && 
#line 240 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
            return 7; /* *movdi_insn */
          break;

        case E_SFmode:
          if (nonimmediate_operand (operands[0], E_SFmode)
              && general_operand (operands[1], E_SFmode)
              && 
#line 265 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
            return 8; /* *movsf_insn */
          break;

        case E_DFmode:
          if (nonimmediate_operand (operands[0], E_DFmode)
              && general_operand (operands[1], E_DFmode)
              && 
#line 265 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
            return 9; /* *movdf_insn */
          break;

        default:
          break;
        }
      if (GET_CODE (x2) != LABEL_REF
          || GET_CODE (x3) != PC)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      return 121; /* jump */

    case UNSPEC:
      return recog_2 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!nvptx_register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !nvptx_nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 16; /* zero_extendqihi2 */

        case E_SImode:
          switch (pattern20 (x2))
            {
            case 0:
              return 17; /* zero_extendqisi2 */

            case 1:
              return 18; /* zero_extendhisi2 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern21 (x2))
            {
            case 0:
              return 19; /* zero_extendqidi2 */

            case 1:
              return 20; /* zero_extendhidi2 */

            case 2:
              return 21; /* zero_extendsidi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!nvptx_register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !nvptx_register_operand (operands[1], E_QImode))
            return -1;
          return 22; /* extendqihi2 */

        case E_SImode:
          switch (pattern20 (x2))
            {
            case 0:
              return 23; /* extendqisi2 */

            case 1:
              return 24; /* extendhisi2 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern21 (x2))
            {
            case 0:
              return 25; /* extendqidi2 */

            case 1:
              return 26; /* extendhidi2 */

            case 2:
              return 27; /* extendsidi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!nvptx_nonimmediate_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_HImode:
                  if (!nvptx_register_operand (operands[1], E_HImode))
                    return -1;
                  return 28; /* trunchiqi2 */

                case E_SImode:
                  if (!nvptx_register_operand (operands[1], E_SImode))
                    return -1;
                  return 29; /* truncsiqi2 */

                case E_DImode:
                  if (!nvptx_register_operand (operands[1], E_DImode))
                    return -1;
                  return 31; /* truncdiqi2 */

                default:
                  return -1;
                }

            case E_HImode:
              if (!nvptx_nonimmediate_operand (operands[0], E_HImode))
                return -1;
              switch (pattern7 (x2, E_HImode))
                {
                case 0:
                  return 30; /* truncsihi2 */

                case 1:
                  return 32; /* truncdihi2 */

                default:
                  return -1;
                }

            case E_SImode:
              if (!nvptx_nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !nvptx_register_operand (operands[1], E_DImode))
                return -1;
              return 33; /* truncdisi2 */

            default:
              return -1;
            }

        case LSHIFTRT:
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != MULT)
            return -1;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != CONST_INT)
            return -1;
          x7 = XEXP (x5, 0);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              switch (pattern38 (x2, SIGN_EXTEND))
                {
                case 0:
                  return 91; /* smulhi3_highpart */

                case 1:
                  return 92; /* smulsi3_highpart */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern38 (x2, ZERO_EXTEND))
                {
                case 0:
                  return 93; /* umulhi3_highpart */

                case 1:
                  return 94; /* umulsi3_highpart */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
          switch (pattern11 (x2))
            {
            case 0:
              return 34; /* addhi3 */

            case 1:
              return 35; /* addsi3 */

            case 2:
              return 36; /* adddi3 */

            case 3:
              return 151; /* addsf3 */

            case 4:
              return 152; /* adddf3 */

            default:
              return -1;
            }

        case PLUS:
          if (pattern14 (x2) != 0)
            return -1;
          return 37; /* *vadd_addsi4 */

        case MINUS:
          if (pattern14 (x2) != 0)
            return -1;
          return 38; /* *vsub_addsi4 */

        case MULT:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          x8 = XEXP (x2, 1);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern42 (x2, E_HImode) != 0)
                return -1;
              return 45; /* *madhi3 */

            case E_SImode:
              if (pattern42 (x2, E_SImode) != 0)
                return -1;
              return 46; /* *madsi3 */

            case E_DImode:
              if (pattern42 (x2, E_DImode) != 0)
                return -1;
              return 47; /* *maddi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern23 (x2, E_HImode) != 0)
            return -1;
          return 39; /* subhi3 */

        case E_SImode:
          if (pattern23 (x2, E_SImode) != 0)
            return -1;
          return 40; /* subsi3 */

        case E_DImode:
          if (pattern23 (x2, E_DImode) != 0)
            return -1;
          return 41; /* subdi3 */

        case E_SFmode:
          if (pattern23 (x2, E_SFmode) != 0)
            return -1;
          return 153; /* subsf3 */

        case E_DFmode:
          if (pattern23 (x2, E_DFmode) != 0)
            return -1;
          return 154; /* subdf3 */

        default:
          return -1;
        }

    case MULT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
          switch (pattern11 (x2))
            {
            case 0:
              return 42; /* mulhi3 */

            case 1:
              return 43; /* mulsi3 */

            case 2:
              return 44; /* muldi3 */

            case 3:
              return 155; /* mulsf3 */

            case 4:
              return 156; /* muldf3 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern16 (x2, SIGN_EXTEND))
            {
            case 0:
              return 87; /* mulhisi3 */

            case 1:
              return 88; /* mulsidi3 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern16 (x2, ZERO_EXTEND))
            {
            case 0:
              return 89; /* umulhisi3 */

            case 1:
              return 90; /* umulsidi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
          switch (pattern11 (x2))
            {
            case 0:
              return 48; /* divhi3 */

            case 1:
              return 49; /* divsi3 */

            case 2:
              return 50; /* divdi3 */

            case 3:
              return 161; /* divsf3 */

            case 4:
              return 162; /* divdf3 */

            default:
              return -1;
            }

        case CONST_DOUBLE:
          operands[2] = x4;
          x8 = XEXP (x2, 1);
          operands[1] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern39 (x2, E_SFmode) != 0
                  || !
#line 965 "../../gcc/config/nvptx/nvptx.md"
(CONST_DOUBLE_P (operands[2])
   && real_identical (CONST_DOUBLE_REAL_VALUE (operands[2]), &dconst1)))
                return -1;
              return 159; /* *recipsf2 */

            case E_DFmode:
              if (pattern39 (x2, E_DFmode) != 0
                  || !
#line 965 "../../gcc/config/nvptx/nvptx.md"
(CONST_DOUBLE_P (operands[2])
   && real_identical (CONST_DOUBLE_REAL_VALUE (operands[2]), &dconst1)))
                return -1;
              return 160; /* *recipdf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UDIV:
      switch (pattern1 (x1))
        {
        case 0:
          return 51; /* udivhi3 */

        case 1:
          return 52; /* udivsi3 */

        case 2:
          return 53; /* udivdi3 */

        default:
          return -1;
        }

    case MOD:
      switch (pattern1 (x1))
        {
        case 0:
          return 54; /* modhi3 */

        case 1:
          return 55; /* modsi3 */

        case 2:
          return 56; /* moddi3 */

        default:
          return -1;
        }

    case UMOD:
      switch (pattern1 (x1))
        {
        case 0:
          return 57; /* umodhi3 */

        case 1:
          return 58; /* umodsi3 */

        case 2:
          return 59; /* umoddi3 */

        default:
          return -1;
        }

    case SMIN:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern11 (x2))
        {
        case 0:
          return 60; /* sminhi3 */

        case 1:
          return 61; /* sminsi3 */

        case 2:
          return 62; /* smindi3 */

        case 3:
          return 165; /* sminsf3 */

        case 4:
          return 166; /* smindf3 */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern1 (x1))
        {
        case 0:
          return 63; /* uminhi3 */

        case 1:
          return 64; /* uminsi3 */

        case 2:
          return 65; /* umindi3 */

        default:
          return -1;
        }

    case SMAX:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern11 (x2))
        {
        case 0:
          return 66; /* smaxhi3 */

        case 1:
          return 67; /* smaxsi3 */

        case 2:
          return 68; /* smaxdi3 */

        case 3:
          return 167; /* smaxsf3 */

        case 4:
          return 168; /* smaxdf3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern1 (x1))
        {
        case 0:
          return 69; /* umaxhi3 */

        case 1:
          return 70; /* umaxsi3 */

        case 2:
          return 71; /* umaxdi3 */

        default:
          return -1;
        }

    case ABS:
      switch (pattern2 (x1))
        {
        case 0:
          return 72; /* abshi2 */

        case 1:
          return 73; /* abssi2 */

        case 2:
          return 74; /* absdi2 */

        case 3:
          return 169; /* abssf2 */

        case 4:
          return 170; /* absdf2 */

        default:
          return -1;
        }

    case NEG:
      switch (pattern2 (x1))
        {
        case 0:
          return 75; /* neghi2 */

        case 1:
          return 76; /* negsi2 */

        case 2:
          return 77; /* negdi2 */

        case 3:
          return 171; /* negsf2 */

        case 4:
          return 172; /* negdf2 */

        default:
          return -1;
        }

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern4 (x2))
        {
        case 0:
          return 78; /* one_cmplhi2 */

        case 1:
          return 79; /* one_cmplsi2 */

        case 2:
          return 80; /* one_cmpldi2 */

        default:
          return -1;
        }

    case CLZ:
      switch (pattern3 (x1))
        {
        case 0:
          return 83; /* clzsi2 */

        case 1:
          return 84; /* clzdi2 */

        default:
          return -1;
        }

    case POPCOUNT:
      switch (pattern3 (x1))
        {
        case 0:
          return 85; /* popcountsi2 */

        case 1:
          return 86; /* popcountdi2 */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern5 (x1))
        {
        case 0:
          return 95; /* ashlhi3 */

        case 1:
          return 96; /* ashlsi3 */

        case 2:
          return 97; /* ashldi3 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern5 (x1))
        {
        case 0:
          return 98; /* ashrhi3 */

        case 1:
          return 99; /* ashrsi3 */

        case 2:
          return 100; /* ashrdi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern5 (x1))
        {
        case 0:
          return 101; /* lshrhi3 */

        case 1:
          return 102; /* lshrsi3 */

        case 2:
          return 103; /* lshrdi3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern6 (x1))
        {
        case 0:
          return 104; /* andbi3 */

        case 1:
          return 105; /* andhi3 */

        case 2:
          return 106; /* andsi3 */

        case 3:
          return 107; /* anddi3 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern6 (x1))
        {
        case 0:
          return 108; /* iorbi3 */

        case 1:
          return 109; /* iorhi3 */

        case 2:
          return 110; /* iorsi3 */

        case 3:
          return 111; /* iordi3 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern6 (x1))
        {
        case 0:
          return 112; /* xorbi3 */

        case 1:
          return 113; /* xorhi3 */

        case 2:
          return 114; /* xorsi3 */

        case 3:
          return 115; /* xordi3 */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_CODE (x2))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          res = recog_1 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      switch (GET_CODE (x2))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[1] = x2;
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          x8 = XEXP (x2, 1);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_BImode:
              switch (pattern44 (E_BImode))
                {
                case 0:
                  return 119; /* *cmpsf */

                case 1:
                  return 120; /* *cmpdf */

                default:
                  return -1;
                }

            case E_SImode:
              switch (pattern44 (E_SImode))
                {
                case 0:
                  return 140; /* setcc_intsf */

                case 1:
                  return 141; /* setcc_intdf */

                default:
                  return -1;
                }

            case E_SFmode:
              switch (pattern44 (E_SFmode))
                {
                case 0:
                  return 145; /* setcc_floatsf */

                case 1:
                  return 146; /* setcc_floatdf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case NE:
          switch (pattern13 (x1))
            {
            case 0:
              return 122; /* br_true */

            case 1:
              return 127; /* sel_truehi */

            case 2:
              return 128; /* sel_truesi */

            case 3:
              return 129; /* sel_truedi */

            case 4:
              return 130; /* sel_truesf */

            case 5:
              return 131; /* sel_truedf */

            case 6:
              return 124; /* br_true_uni */

            default:
              return -1;
            }

        case EQ:
          switch (pattern13 (x1))
            {
            case 0:
              return 123; /* br_false */

            case 1:
              return 132; /* sel_falsehi */

            case 2:
              return 133; /* sel_falsesi */

            case 3:
              return 134; /* sel_falsedi */

            case 4:
              return 135; /* sel_falsesf */

            case 5:
              return 136; /* sel_falsedf */

            case 6:
              return 125; /* br_false_uni */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FMA:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      x9 = XEXP (x2, 2);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern40 (x2, E_SFmode) != 0)
            return -1;
          return 157; /* fmasf4 */

        case E_DFmode:
          if (pattern40 (x2, E_DFmode) != 0)
            return -1;
          return 158; /* fmadf4 */

        default:
          return -1;
        }

    case SQRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!nvptx_register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !nvptx_register_operand (operands[1], E_SFmode))
            return -1;
          return 173; /* sqrtsf2 */

        case E_DFmode:
          if (!nvptx_register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !nvptx_register_operand (operands[1], E_DFmode))
            return -1;
          return 174; /* sqrtdf2 */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!nvptx_register_operand (operands[0], E_DFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 179; /* extendsfdf2 */

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!nvptx_register_operand (operands[0], E_SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 180; /* truncdfsf2 */

    case UNSIGNED_FLOAT:
      switch (pattern8 (x1))
        {
        case 0:
          return 181; /* floatunssisf2 */

        case 1:
          return 185; /* floatunsdisf2 */

        case 2:
          return 182; /* floatunssidf2 */

        case 3:
          return 186; /* floatunsdidf2 */

        default:
          return -1;
        }

    case FLOAT:
      switch (pattern8 (x1))
        {
        case 0:
          return 183; /* floatsisf2 */

        case 1:
          return 187; /* floatdisf2 */

        case 2:
          return 184; /* floatsidf2 */

        case 3:
          return 188; /* floatdidf2 */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern10 (x1))
        {
        case 0:
          return 189; /* fixuns_truncsfsi2 */

        case 1:
          return 190; /* fixuns_truncdfsi2 */

        case 2:
          return 193; /* fixuns_truncsfdi2 */

        case 3:
          return 194; /* fixuns_truncdfdi2 */

        default:
          return -1;
        }

    case FIX:
      switch (pattern10 (x1))
        {
        case 0:
          return 191; /* fix_truncsfsi2 */

        case 1:
          return 192; /* fix_truncdfsi2 */

        case 2:
          return 195; /* fix_truncsfdi2 */

        case 3:
          return 196; /* fix_truncdfdi2 */

        default:
          return -1;
        }

    case VEC_MERGE:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != VEC_DUPLICATE)
        return -1;
      x9 = XEXP (x2, 2);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x8 = XEXP (x2, 1);
      if (!rtx_equal_p (x8, operands[0]))
        return -1;
      switch (XWINT (x9, 0))
        {
        case 1L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern47 (x2, E_SImode, E_V2SImode) != 0)
                return -1;
              return 213; /* *vec_setv2si_0 */

            case E_V2DImode:
              if (pattern47 (x2, E_DImode, E_V2DImode) != 0)
                return -1;
              return 214; /* *vec_setv2di_0 */

            default:
              return -1;
            }

        case 2L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern47 (x2, E_SImode, E_V2SImode) != 0)
                return -1;
              return 215; /* *vec_setv2si_1 */

            case E_V2DImode:
              if (pattern47 (x2, E_DImode, E_V2DImode) != 0)
                return -1;
              return 216; /* *vec_setv2di_1 */

            default:
              return -1;
            }

        case 4L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern47 (x2, E_SImode, E_V2SImode) != 0)
                return -1;
              return 217; /* *vec_setv2si_2 */

            case E_V2DImode:
              if (pattern47 (x2, E_DImode, E_V2DImode) != 0)
                return -1;
              return 218; /* *vec_setv2di_2 */

            default:
              return -1;
            }

        case 8L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern47 (x2, E_SImode, E_V2SImode) != 0)
                return -1;
              return 219; /* *vec_setv2si_3 */

            case E_V2DImode:
              if (pattern47 (x2, E_DImode, E_V2DImode) != 0)
                return -1;
              return 220; /* *vec_setv2di_3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x8 = XEXP (x2, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x10 = XVECEXP (x8, 0, 0);
      operands[2] = x10;
      if (!nvptx_vector_index_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !nvptx_register_operand (operands[1], E_V2SImode))
            return -1;
          return 221; /* vec_extractv2sisi */

        case E_DImode:
          if (!nvptx_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !nvptx_register_operand (operands[1], E_V2DImode))
            return -1;
          return 222; /* vec_extractv2didi */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XVECLEN (x2, 0))
        {
        case 1:
          switch (XINT (x2, 1))
            {
            case 6:
              if (GET_MODE (x2) != E_SImode
                  || !nvptx_register_operand (operands[0], E_SImode))
                return -1;
              x11 = XVECEXP (x2, 0, 0);
              operands[1] = x11;
              if (!const_int_operand (operands[1], E_SImode))
                return -1;
              return 233; /* oacc_dim_pos */

            case 4:
              if (GET_MODE (x2) != E_BLKmode)
                return -1;
              x11 = XVECEXP (x2, 0, 0);
              if (!rtx_equal_p (x11, operands[0]))
                return -1;
              return 264; /* *memory_barrier */

            case 5:
              if (GET_MODE (x2) != E_BLKmode)
                return -1;
              x11 = XVECEXP (x2, 0, 0);
              if (!rtx_equal_p (x11, operands[0]))
                return -1;
              return 265; /* *nvptx_membar_cta */

            case 14:
              if (GET_MODE (x2) != E_DImode
                  || !nonimmediate_operand (operands[0], E_DImode))
                return -1;
              x11 = XVECEXP (x2, 0, 0);
              operands[1] = x11;
              if (!const_int_operand (operands[1], E_DImode))
                return -1;
              return 267; /* nvptx_red_partition */

            default:
              return -1;
            }

        case 2:
          if (XINT (x2, 1) != 12)
            return -1;
          x11 = XVECEXP (x2, 0, 0);
          operands[1] = x11;
          x12 = XVECEXP (x2, 0, 1);
          operands[2] = x12;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern45 (x2, E_SImode) != 0
                  || !
#line 206 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
                return -1;
              return 241; /* omp_simt_enter_si */

            case E_DImode:
              if (pattern45 (x2, E_DImode) != 0
                  || !
#line 206 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
                return -1;
              return 242; /* omp_simt_enter_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_10 (x1, insn, pnum_clobbers);

    case PARALLEL:
      if (XVECLEN (x1, 0) >= 1
          && call_operation (x1, E_VOIDmode))
        {
          res = recog_3 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (x1, 0) != 2)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != SET)
        return -1;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case UNSPEC:
          if (XVECLEN (x4, 0) != 2
              || XINT (x4, 1) != 14
              || GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XVECEXP (x4, 0, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x6 = XEXP (x3, 1);
          if (GET_CODE (x6) != UNSPEC
              || XVECLEN (x6, 0) != 2
              || XINT (x6, 1) != 14
              || GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XVECEXP (x6, 0, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          if (!nvptx_register_operand (operands[0], E_SImode))
            return -1;
          x9 = XVECEXP (x4, 0, 0);
          operands[2] = x9;
          x10 = XEXP (x3, 0);
          operands[1] = x10;
          if (!nvptx_register_operand (operands[1], E_SImode))
            return -1;
          x11 = XVECEXP (x6, 0, 0);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_DImode:
              if (!nvptx_register_operand (operands[2], E_DImode))
                return -1;
              return 246; /* unpackdisi2 */

            case E_DFmode:
              if (!nvptx_register_operand (operands[2], E_DFmode))
                return -1;
              return 247; /* unpackdfsi2 */

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          switch (XVECLEN (x4, 0))
            {
            case 4:
              if (XINT (x4, 1) != 1)
                return -1;
              x6 = XEXP (x3, 1);
              if (GET_CODE (x6) != UNSPEC_VOLATILE
                  || XVECLEN (x6, 0) != 1
                  || XINT (x6, 1) != 1)
                return -1;
              x11 = XVECEXP (x6, 0, 0);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x8 = XEXP (x2, 0);
              operands[0] = x8;
              x9 = XVECEXP (x4, 0, 0);
              operands[1] = x9;
              x5 = XVECEXP (x4, 0, 1);
              operands[2] = x5;
              x12 = XVECEXP (x4, 0, 2);
              operands[3] = x12;
              x13 = XVECEXP (x4, 0, 3);
              operands[4] = x13;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              x10 = XEXP (x3, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern71 (x1, E_SImode) != 0)
                    return -1;
                  return 250; /* atomic_compare_and_swapsi_1 */

                case E_DImode:
                  if (pattern71 (x1, E_DImode) != 0)
                    return -1;
                  return 251; /* atomic_compare_and_swapdi_1 */

                default:
                  return -1;
                }

            case 2:
              x5 = XVECEXP (x4, 0, 1);
              operands[3] = x5;
              if (!const_int_operand (operands[3], E_SImode))
                return -1;
              switch (XINT (x4, 1))
                {
                case 2:
                  x8 = XEXP (x2, 0);
                  operands[0] = x8;
                  x9 = XVECEXP (x4, 0, 0);
                  operands[1] = x9;
                  x6 = XEXP (x3, 1);
                  operands[2] = x6;
                  x10 = XEXP (x3, 0);
                  if (!rtx_equal_p (x10, operands[1]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern60 (x4, E_SImode) != 0)
                        return -1;
                      return 252; /* atomic_exchangesi */

                    case E_DImode:
                      if (pattern60 (x4, E_DImode) != 0)
                        return -1;
                      return 253; /* atomic_exchangedi */

                    default:
                      return -1;
                    }

                case 0:
                  x8 = XEXP (x2, 0);
                  operands[1] = x8;
                  x10 = XEXP (x3, 0);
                  operands[0] = x10;
                  x6 = XEXP (x3, 1);
                  if (!rtx_equal_p (x6, operands[1]))
                    return -1;
                  x9 = XVECEXP (x4, 0, 0);
                  switch (GET_CODE (x9))
                    {
                    case PLUS:
                      x14 = XEXP (x9, 1);
                      operands[2] = x14;
                      x15 = XEXP (x9, 0);
                      if (!rtx_equal_p (x15, operands[1]))
                        return -1;
                      switch (GET_MODE (operands[1]))
                        {
                        case E_SImode:
                          if (pattern55 (x4, E_SImode) != 0)
                            return -1;
                          return 254; /* atomic_fetch_addsi */

                        case E_DImode:
                          if (pattern55 (x4, E_DImode) != 0)
                            return -1;
                          return 255; /* atomic_fetch_adddi */

                        case E_SFmode:
                          if (pattern55 (x4, E_SFmode) != 0)
                            return -1;
                          return 256; /* atomic_fetch_addsf */

                        default:
                          return -1;
                        }

                    case AND:
                      switch (pattern56 (x4))
                        {
                        case 0:
                          return 257; /* atomic_fetch_andsi */

                        case 1:
                          if (!
#line 1688 "../../gcc/config/nvptx/nvptx.md"
(DImode == SImode || TARGET_SM35))
                            return -1;
                          return 260; /* atomic_fetch_anddi */

                        default:
                          return -1;
                        }

                    case IOR:
                      switch (pattern56 (x4))
                        {
                        case 0:
                          return 258; /* atomic_fetch_orsi */

                        case 1:
                          if (!
#line 1688 "../../gcc/config/nvptx/nvptx.md"
(DImode == SImode || TARGET_SM35))
                            return -1;
                          return 261; /* atomic_fetch_ordi */

                        default:
                          return -1;
                        }

                    case XOR:
                      switch (pattern56 (x4))
                        {
                        case 0:
                          return 259; /* atomic_fetch_xorsi */

                        case 1:
                          if (!
#line 1688 "../../gcc/config/nvptx/nvptx.md"
(DImode == SImode || TARGET_SM35))
                            return -1;
                          return 262; /* atomic_fetch_xordi */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      switch (XWINT (x1, 0))
        {
        case 0L:
          return 223; /* nop */

        case 1L:
          return 224; /* exit */

        case 2L:
          return 225; /* fake_nop */

        default:
          return -1;
        }

    case RETURN:
      return 226; /* return */

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 12)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[0] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!nvptx_register_operand (operands[0], E_SImode)
              || !(
#line 1303 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SOFT_STACK) && 
#line 206 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode)))
            return -1;
          return 227; /* set_softstack_si */

        case E_DImode:
          if (!nvptx_register_operand (operands[0], E_DImode)
              || !(
#line 1303 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SOFT_STACK) && 
#line 206 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode)))
            return -1;
          return 228; /* set_softstack_di */

        default:
          return -1;
        }

    case TRAP_IF:
      x16 = XEXP (x1, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x17 = XEXP (x1, 0);
      switch (GET_CODE (x17))
        {
        case CONST_INT:
          if (XWINT (x17, 0) != 1L)
            return -1;
          return 229; /* trap */

        case NE:
          x18 = XEXP (x17, 1);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x19 = XEXP (x17, 0);
          operands[0] = x19;
          if (!nvptx_register_operand (operands[0], E_BImode))
            return -1;
          return 230; /* trap_if_true */

        case EQ:
          x18 = XEXP (x17, 1);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x19 = XEXP (x17, 0);
          operands[0] = x19;
          if (!nvptx_register_operand (operands[0], E_BImode))
            return -1;
          return 231; /* trap_if_false */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 7:
              if (GET_MODE (x1) != E_SImode)
                return -1;
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              return 234; /* nvptx_fork */

            case 8:
              if (GET_MODE (x1) != E_SImode)
                return -1;
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              return 235; /* nvptx_forked */

            case 9:
              if (GET_MODE (x1) != E_SImode)
                return -1;
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              return 236; /* nvptx_joining */

            case 10:
              if (GET_MODE (x1) != E_SImode)
                return -1;
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              return 237; /* nvptx_join */

            case 13:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!nvptx_register_operand (operands[0], E_SImode)
                      || !
#line 206 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
                    return -1;
                  return 243; /* omp_simt_exit_si */

                case E_DImode:
                  if (!nvptx_register_operand (operands[0], E_DImode)
                      || !
#line 206 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
                    return -1;
                  return 244; /* omp_simt_exit_di */

                default:
                  return -1;
                }

            case 11:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 266; /* nvptx_nounroll */

            default:
              return -1;
            }

        case 2:
          if (XINT (x1, 1) != 3)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!nvptx_nonmemory_operand (operands[0], E_SImode))
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          operands[1] = x3;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          return 263; /* nvptx_barsync */

        default:
          return -1;
        }

    case COND_EXEC:
      x17 = XEXP (x1, 0);
      if (!predicate_operator (x17, E_VOIDmode))
        return -1;
      x19 = XEXP (x17, 0);
      if (!nvptx_register_operand (x19, E_BImode))
        return -1;
      x18 = XEXP (x17, 1);
      if (!const0_operand (x18, E_BImode))
        return -1;
      x16 = XEXP (x1, 1);
      switch (GET_CODE (x16))
        {
        case SET:
          return recog_9 (x1, insn, pnum_clobbers);

        case PARALLEL:
          if (XVECLEN (x16, 0) >= 1
              && call_operation (x16, E_VOIDmode))
            {
              res = recog_8 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (XVECLEN (x16, 0) != 2)
            return -1;
          x20 = XVECEXP (x16, 0, 0);
          if (GET_CODE (x20) != SET)
            return -1;
          x21 = XVECEXP (x16, 0, 1);
          if (GET_CODE (x21) != SET)
            return -1;
          x22 = XEXP (x20, 1);
          switch (GET_CODE (x22))
            {
            case UNSPEC:
              if (XVECLEN (x22, 0) != 2
                  || XINT (x22, 1) != 14
                  || GET_MODE (x22) != E_SImode)
                return -1;
              x23 = XVECEXP (x22, 0, 1);
              if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x24 = XEXP (x21, 1);
              if (GET_CODE (x24) != UNSPEC
                  || XVECLEN (x24, 0) != 2
                  || XINT (x24, 1) != 14
                  || GET_MODE (x24) != E_SImode)
                return -1;
              x25 = XVECEXP (x24, 0, 1);
              if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              operands[3] = x17;
              operands[4] = x19;
              operands[5] = x18;
              x26 = XEXP (x20, 0);
              operands[0] = x26;
              if (!nvptx_register_operand (operands[0], E_SImode))
                return -1;
              x27 = XVECEXP (x22, 0, 0);
              operands[2] = x27;
              x28 = XEXP (x21, 0);
              operands[1] = x28;
              if (!nvptx_register_operand (operands[1], E_SImode))
                return -1;
              x29 = XVECEXP (x24, 0, 0);
              if (!rtx_equal_p (x29, operands[2]))
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_DImode:
                  if (!nvptx_register_operand (operands[2], E_DImode))
                    return -1;
                  return 551; /* *p unpackdisi2 */

                case E_DFmode:
                  if (!nvptx_register_operand (operands[2], E_DFmode))
                    return -1;
                  return 552; /* *p unpackdfsi2 */

                default:
                  return -1;
                }

            case UNSPEC_VOLATILE:
              switch (XVECLEN (x22, 0))
                {
                case 4:
                  if (XINT (x22, 1) != 1)
                    return -1;
                  x24 = XEXP (x21, 1);
                  if (GET_CODE (x24) != UNSPEC_VOLATILE
                      || XVECLEN (x24, 0) != 1
                      || XINT (x24, 1) != 1)
                    return -1;
                  x29 = XVECEXP (x24, 0, 0);
                  if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return -1;
                  operands[5] = x17;
                  operands[6] = x19;
                  operands[7] = x18;
                  x26 = XEXP (x20, 0);
                  operands[0] = x26;
                  x27 = XVECEXP (x22, 0, 0);
                  operands[1] = x27;
                  x23 = XVECEXP (x22, 0, 1);
                  operands[2] = x23;
                  x30 = XVECEXP (x22, 0, 2);
                  operands[3] = x30;
                  x31 = XVECEXP (x22, 0, 3);
                  operands[4] = x31;
                  if (!const_int_operand (operands[4], E_SImode))
                    return -1;
                  x28 = XEXP (x21, 0);
                  if (!rtx_equal_p (x28, operands[1]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern75 (x16, E_SImode) != 0)
                        return -1;
                      return 555; /* *p atomic_compare_and_swapsi_1 */

                    case E_DImode:
                      if (pattern75 (x16, E_DImode) != 0)
                        return -1;
                      return 556; /* *p atomic_compare_and_swapdi_1 */

                    default:
                      return -1;
                    }

                case 2:
                  operands[4] = x17;
                  operands[5] = x19;
                  operands[6] = x18;
                  x23 = XVECEXP (x22, 0, 1);
                  operands[3] = x23;
                  if (!const_int_operand (operands[3], E_SImode))
                    return -1;
                  switch (XINT (x22, 1))
                    {
                    case 2:
                      x26 = XEXP (x20, 0);
                      operands[0] = x26;
                      x27 = XVECEXP (x22, 0, 0);
                      operands[1] = x27;
                      x24 = XEXP (x21, 1);
                      operands[2] = x24;
                      x28 = XEXP (x21, 0);
                      if (!rtx_equal_p (x28, operands[1]))
                        return -1;
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern74 (x22, E_SImode) != 0)
                            return -1;
                          return 557; /* *p atomic_exchangesi */

                        case E_DImode:
                          if (pattern74 (x22, E_DImode) != 0)
                            return -1;
                          return 558; /* *p atomic_exchangedi */

                        default:
                          return -1;
                        }

                    case 0:
                      x26 = XEXP (x20, 0);
                      operands[1] = x26;
                      x28 = XEXP (x21, 0);
                      operands[0] = x28;
                      x24 = XEXP (x21, 1);
                      if (!rtx_equal_p (x24, operands[1]))
                        return -1;
                      x27 = XVECEXP (x22, 0, 0);
                      switch (GET_CODE (x27))
                        {
                        case PLUS:
                          x32 = XEXP (x27, 1);
                          operands[2] = x32;
                          x33 = XEXP (x27, 0);
                          if (!rtx_equal_p (x33, operands[1]))
                            return -1;
                          switch (GET_MODE (operands[1]))
                            {
                            case E_SImode:
                              if (pattern72 (x22, E_SImode) != 0)
                                return -1;
                              return 559; /* *p atomic_fetch_addsi */

                            case E_DImode:
                              if (pattern72 (x22, E_DImode) != 0)
                                return -1;
                              return 560; /* *p atomic_fetch_adddi */

                            case E_SFmode:
                              if (pattern72 (x22, E_SFmode) != 0)
                                return -1;
                              return 561; /* *p atomic_fetch_addsf */

                            default:
                              return -1;
                            }

                        case AND:
                          switch (pattern73 (x22))
                            {
                            case 0:
                              return 562; /* *p atomic_fetch_andsi */

                            case 1:
                              if (!
#line 1688 "../../gcc/config/nvptx/nvptx.md"
(DImode == SImode || TARGET_SM35))
                                return -1;
                              return 565; /* *p atomic_fetch_anddi */

                            default:
                              return -1;
                            }

                        case IOR:
                          switch (pattern73 (x22))
                            {
                            case 0:
                              return 563; /* *p atomic_fetch_orsi */

                            case 1:
                              if (!
#line 1688 "../../gcc/config/nvptx/nvptx.md"
(DImode == SImode || TARGET_SM35))
                                return -1;
                              return 566; /* *p atomic_fetch_ordi */

                            default:
                              return -1;
                            }

                        case XOR:
                          switch (pattern73 (x22))
                            {
                            case 0:
                              return 564; /* *p atomic_fetch_xorsi */

                            case 1:
                              if (!
#line 1688 "../../gcc/config/nvptx/nvptx.md"
(DImode == SImode || TARGET_SM35))
                                return -1;
                              return 567; /* *p atomic_fetch_xordi */

                            default:
                              return -1;
                            }

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CONST_INT:
          operands[0] = x17;
          operands[1] = x19;
          operands[2] = x18;
          switch (XWINT (x16, 0))
            {
            case 0L:
              return 535; /* *p nop */

            case 1L:
              return 536; /* *p exit */

            case 2L:
              return 537; /* *p fake_nop */

            default:
              return -1;
            }

        case UNSPEC:
          switch (pattern22 (x1, 12))
            {
            case 0:
              if (!(
#line 1303 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SOFT_STACK) && 
#line 206 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode)))
                return -1;
              return 538; /* *p set_softstack_si */

            case 1:
              if (!(
#line 1303 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SOFT_STACK) && 
#line 206 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode)))
                return -1;
              return 539; /* *p set_softstack_di */

            default:
              return -1;
            }

        case TRAP_IF:
          x34 = XEXP (x16, 0);
          if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x35 = XEXP (x16, 1);
          if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          operands[0] = x17;
          operands[1] = x19;
          operands[2] = x18;
          return 540; /* *p trap */

        case UNSPEC_VOLATILE:
          switch (pattern22 (x1, 13))
            {
            case 0:
              if (!
#line 206 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
                return -1;
              return 548; /* *p omp_simt_exit_si */

            case 1:
              if (!
#line 206 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
                return -1;
              return 549; /* *p omp_simt_exit_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != CONST
      || GET_MODE (x2) != E_DImode)
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_DImode)
    return NULL;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!nvptx_register_operand (operands[0], E_DImode))
    return NULL;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!symbol_ref_function_operand (operands[1], E_DImode))
    return NULL;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return NULL;
  return gen_split_1 (insn, operands);
}

rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  return NULL;
}
